## xeus-zmq 1.1.0

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.8)
project(xeus-zmq)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
set(XEUS_ZMQ_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(XEUS_ZMQ_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(XEUS_ZMQ_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)

# Versionning
# ===========

# Project version
file(STRINGS "${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp" xeus_zmq_version_defines
     REGEX "#define XEUS_ZMQ_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xeus_zmq_version_defines})
    if(ver MATCHES "#define XEUS_ZMQ_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XEUS_ZMQ_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_ZMQ_VERSION
    ${XEUS_ZMQ_VERSION_MAJOR}.${XEUS_ZMQ_VERSION_MINOR}.${XEUS_ZMQ_VERSION_PATCH})
message(STATUS "xeus version: v${XEUS_ZMQ_VERSION}")

# Binary version
# See the following URL for explanations about the binary versionning
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
file(STRINGS "${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp" xeus_zmq_version_defines
    REGEX "#define XEUS_ZMQ_BINARY_(CURRENT|REVISION|AGE)")
foreach(ver ${xeus_zmq_version_defines})
    if(ver MATCHES "#define XEUS_ZMQ_BINARY_(CURRENT|REVISION|AGE) +([^ ]+)$")
        set(XEUS_ZMQ_BINARY_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_ZMQ_BINARY_VERSION
    ${XEUS_ZMQ_BINARY_CURRENT}.${XEUS_ZMQ_BINARY_REVISION}.${XEUS_ZMQ_BINARY_AGE})
message(STATUS "xeus binary version: v${XEUS_ZMQ_BINARY_VERSION}")

# Build options
# =============

# Compilation options
option(XEUS_ZMQ_BUILD_SHARED_LIBS "Build xeus shared library." ON)
option(XEUS_ZMQ_BUILD_STATIC_LIBS "Build xeus static library (default if BUILD_SHARED_LIBS is OFF)." ON)
option(XEUS_ZMQ_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)

# Test options
option(XEUS_ZMQ_BUILD_TESTS "xeus test suite" OFF)

# Static build configuration
# ==========================

if (XEUS_ZMQ_STATIC_DEPENDENCIES)
    set(CPPZMQ_TARGET_NAME cppzmq-static)
    set(XEUS_TARGET_NAME xeus-static)
    set(OPENSSL_USE_STATIC_LIBS ON CACHE BOOL "Linking statically with OpenSSL")
else()
    set(CPPZMQ_TARGET_NAME cppzmq)
    set(XEUS_TARGET_NAME xeus)
    set(OPENSSL_USE_STATIC_LIBS OFF CACHE BOOL "Not linking statically with OpenSSL")
endif()

# Print build configuration
# ==========================

message(STATUS "XEUS_ZMQ_BUILD_SHARED_LIBS:          ${XEUS_ZMQ_BUILD_SHARED_LIBS}")
message(STATUS "XEUS_ZMQ_BUILD_STATIC_LIBS:          ${XEUS_ZMQ_BUILD_STATIC_LIBS}")
message(STATUS "XEUS_ZMQ_STATIC_DEPENDENCIES:        ${XEUS_ZMQ_STATIC_DEPENDENCIES}")  
message(STATUS "XEUS_ZMQ_BUILD_TESTS:                ${XEUS_ZMQ_BUILD_TESTS}")  

# Dependencies
# ============

set(xeus_REQUIRED_VERSION 3.0.0)
set(nlohmann_json_REQUIRED_VERSION 3.2.0)
set(cppzmq_REQUIRED_VERSION 4.8.1)
set(zeromq_REQUIRED_VERSION 4.3.2)

if (NOT TARGET xeus AND NOT TARGET xeus-static)
    find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET nlohmann_json)
    find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET cppzmq AND NOT TARGET cppzmq-static)
    find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
    if (WIN32)
        find_package(zeromq ${zeromq_REQUIRED_VERSION} REQUIRED)
    else ()
        find_package(zeromq ${zeromq_REQUIRED_VERSION} QUIET)

        if (NOT ZeroMQ_FOUND)
            message(STATUS "CMake libzmq package not found, trying again with pkg-config")
            find_package(PkgConfig)
            pkg_check_modules(ZeroMQ libzmq>=${zeromq_REQUIRED_VERSION} REQUIRED)
            set(ZeroMQ_VERSION ${PC_LIBZMQ_VERSION})
            find_library(ZeroMQ_LIBRARY NAMES libzmq.so libzmq.dylib libzmq.dll
                 PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
            find_library(ZeroMQ_STATIC_LIBRARY NAMES libzmq-static.a libzmq.a libzmq.dll.a
                 PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
            message(STATUS "STATIC_LIBRARY" {ZeroMQ_LIBRARY})
            message(STATUS "STATIC_STATIC_LIBRARY" {ZeroMQ_STATIC_LIBRARY})
         endif ()
    endif ()
endif ()

find_package(OpenSSL REQUIRED)

# Source files
# ============

set(XEUS_ZMQ_HEADERS
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xauthentication.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdebugger_base.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_control_main.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xmiddleware.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_shell_main.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq_split.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xthread.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_context.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_serializer.hpp
)

set(XEUS_ZMQ_SOURCES
    ${XEUS_ZMQ_SOURCE_DIR}/xauthentication.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xdap_tcp_client.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xdebugger_base.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xmiddleware.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_control_main.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_shell_main.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq_split.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xshell.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xshell.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_context.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_serializer.cpp
)

# Targets and link
# ================

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE)
	# Explicitly finds and links with libsodium.a
	# because it is not exported as a dependency by
	# the static build of libzmq. Remove this when
	# it is fixed upstream.
	set(sodium_USE_STATIC_LIBS ON)
	find_package(sodium REQUIRED)
endif ()

macro(xeus_zmq_create_target target_name linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    # Output
    # ======

    add_library(${target_name} ${linkage_upper} ${XEUS_ZMQ_SOURCES} ${XEUS_ZMQ_HEADERS})

    target_include_directories(
        ${target_name}
        PUBLIC $<BUILD_INTERFACE:${XEUS_ZMQ_INCLUDE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    target_link_libraries(
        ${target_name}
        PUBLIC ${CPPZMQ_TARGET_NAME}
        PUBLIC nlohmann_json::nlohmann_json
        PUBLIC OpenSSL::Crypto
        PUBLIC ${XEUS_TARGET_NAME}
    )

    if (NOT MSVC)
        if (APPLE)
            target_link_libraries(${target_name} PUBLIC "-framework CoreFoundation")
        else ()
            if (XEUS_ZMQ_STATIC_DEPENDENCIES)
                target_link_libraries(${target_name} PUBLIC ${sodium_LIBRARY_RELEASE})
            endif ()
        endif ()
    endif ()

    if (UNIX)
        # CMake does not compute the version number of so files as libtool
        # does on Linux. Strictly speaking, we should exclude FreeBSD and
        # Apple from this, but that would require having different version
        # numbers depending on the platform. We prefer to follow the
        # libtool pattern everywhere.
        math(EXPR XEUS_ZMQ_BINARY_COMPATIBLE "${XEUS_ZMQ_BINARY_CURRENT} - ${XEUS_ZMQ_BINARY_AGE}")
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_ZMQ_HEADERS}"
            COMPILE_OPTIONS "-fvisibility=hidden"
            COMPILE_DEFINITIONS "XEUS_ZMQ_EXPORTS"
            PREFIX ""
            VERSION
            "${XEUS_ZMQ_BINARY_COMPATIBLE}.${XEUS_ZMQ_BINARY_REVISION}.${XEUS_ZMQ_BINARY_AGE}"
            SOVERSION ${XEUS_ZMQ_BINARY_COMPATIBLE}
            OUTPUT_NAME "lib${output_name}"
        )
    else()
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_ZMQ_HEADERS}"
            COMPILE_DEFINITIONS "XEUS_ZMQ_EXPORTS"
            PREFIX ""
            VERSION ${XEUS_ZMQ_BINARY_VERSION}
            SOVERSION ${XEUS_ZMQ_BINARY_CURRENT}
            OUTPUT_NAME "lib${output_name}"
        )
    endif()

    # Compilation flags
    # =================

    target_compile_features(${target_name} PRIVATE cxx_std_14)

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
        CMAKE_CXX_COMPILER_ID MATCHES "Intel")

        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)

        message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
    endif()

    if (${linkage_upper} STREQUAL "STATIC")
        target_compile_definitions(${target_name} PUBLIC XEUS_ZMQ_STATIC_LIB)
    endif ()

    if (MSVC)
        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
    elseif (APPLE)
        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
    else ()
        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
    endif ()

    if (XEUS_ZMQ_STATIC_DEPENDENCIES)
        if (CMAKE_DL_LIBS)
            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS})
        endif ()
        if (UNIX AND NOT APPLE)
            target_link_libraries(${target_name} PRIVATE util rt)
        endif ()
    endif ()
endmacro()

set(xeus_zmq_targets "")

if (XEUS_ZMQ_BUILD_SHARED_LIBS)
    xeus_zmq_create_target(xeus-zmq SHARED xeus-zmq)
    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
        # Do not reexport OpenSSL symbols from xeus, for libraries
        #   Prevents conflicts with other versions of OpenSSL
        #   loaded in the same process namespace, which can cause
        #   crashes if the versions are not compatible.
        set_target_properties(xeus-zmq PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
    endif()
    list(APPEND xeus_zmq_targets xeus-zmq)
endif ()

if (XEUS_ZMQ_BUILD_STATIC_LIBS)
    # On Windows, a static library should use a different output name
    # to avoid the conflict with the import library of a shared one.
    if (CMAKE_HOST_WIN32)
        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq-static)
    else ()
        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq)
    endif ()

    list(APPEND xeus_zmq_targets xeus-zmq-static)
endif ()

# Tests
# =====

# We need to control from outside whether we enable testing or not. We cannot
# rely on BUILD_TESTING since it doe snot exist until CTest is included.

include(CTest)

=== debian/changelog ===
xeus-zmq (1.1.0-2) unstable; urgency=medium

  * Source-only upload 

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:25:01 +0000

xeus-zmq (1.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1042462)

 -- Gordon Ball <gordon@chronitis.net>  Fri, 28 Jul 2023 19:37:22 +0000

=== debian/control ===
Source: xeus-zmq
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cppzmq-dev,
               xeus-dev (>= 3.1.1~),
               nlohmann-json3-dev,
               libssl-dev,
               pkg-config,
               doctest-dev,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/jupyter-xeus/xeus-zmq
Vcs-Git: https://salsa.debian.org/science-team/xeus-zmq.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus
Rules-Requires-Root: no

Package: libxeus-zmq2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ZeroMQ middleware for xeus (library)
 xeus-zmq provides the ZMQ transport for the Jupyter kernel protocol. This
 was formerly part of libxeus but was split into a separate library for
 xeus >= 3
 .
 This package contains the shared library.

Package: xeus-zmq-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libxeus-zmq2 (= ${binary:Version}),
         xeus-dev (>= 3.1.1~),
         cppzmq-dev,
         nlohmann-json3-dev,
         libssl-dev,
Description: ZeroMQ middleware for xeus (headers)
 xeus enables custom kernel authors to implement Jupyter kernels more
 easily. It takes the burden of implementing the Jupyter Kernel protocol
 so developers can focus on implementing the interpreter part of the Kernel.
 .
 This package contains the headers and cmake config.

## xeus-zmq 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endforeach()
 set(XEUS_ZMQ_VERSION
     ${XEUS_ZMQ_VERSION_MAJOR}.${XEUS_ZMQ_VERSION_MINOR}.${XEUS_ZMQ_VERSION_PATCH})
-message(STATUS "xeus version: v${XEUS_ZMQ_VERSION}")
+message(STATUS "xeus-zmq version: v${XEUS_ZMQ_VERSION}")
 
 # Binary version
 # See the following URL for explanations about the binary versionning
@@ -42,7 +42,7 @@
 endforeach()
 set(XEUS_ZMQ_BINARY_VERSION
     ${XEUS_ZMQ_BINARY_CURRENT}.${XEUS_ZMQ_BINARY_REVISION}.${XEUS_ZMQ_BINARY_AGE})
-message(STATUS "xeus binary version: v${XEUS_ZMQ_BINARY_VERSION}")
+message(STATUS "xeus-zmq binary version: v${XEUS_ZMQ_BINARY_VERSION}")
 
 # Build options
 # =============
@@ -79,7 +79,7 @@
 # Dependencies
 # ============
 
-set(xeus_REQUIRED_VERSION 3.0.0)
+set(xeus_REQUIRED_VERSION 3.1.1)
 set(nlohmann_json_REQUIRED_VERSION 3.2.0)
 set(cppzmq_REQUIRED_VERSION 4.8.1)
 set(zeromq_REQUIRED_VERSION 4.3.2)

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Sylvain Corlay, Johan Mabille, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

# Unit tests
# ==========

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xeus-zmq-test)

    enable_testing()

    find_package(xeus-zmq REQUIRED CONFIG)
    find_package(nlohmann_json QUIET CONFIG)

    set(XEUS_ZMQ_TEST_DIR ${CMAKE_CURRENT_LIST_DIR})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if(nlohmann_json_FOUND)
  add_definitions(-DHAVE_NLOHMANN_JSON)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES Clang OR CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
    add_compile_options(/EHsc /MP /bigobj)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()


find_package(doctest REQUIRED)
find_package(Threads)

find_program(PYTEST  
    NAMES pytest-3 pytest py.test-3 py.test REQUIRED)

if(nlohmann_json_FOUND)
    # Version up to 3.1.2 export the target `nlohmann_json`
    if(TARGET nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json)
    # Newer versions export the namespaced target `nlohmann_json::nlohmann_json`
    elseif(TARGET nlohmann_json::nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json::nlohmann_json)
    endif()
endif()

if (TARGET xeus-zmq)
    set(xeus-zmq_TARGET xeus-zmq)
    message("Found xeus-zmq shared library.")
elseif (TARGET xeus-zmq-static)
    set(xeus-zmq_TARGET xeus-zmq-static)
    message("Found xeus-zmq static library.")
endif ()

# Test_kernel tests
# =================

set(TEST_KERNEL_SOURCES
    xmock_interpreter.cpp
    xmock_interpreter.hpp
    main.cpp)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel/kernel.json.in"
    "kernels/test_kernel/kernel.json"
)

add_executable(test_kernel ${TEST_KERNEL_SOURCES})
target_link_libraries(test_kernel PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
target_compile_features(test_kernel PRIVATE cxx_std_11)

set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel.py"
    "${CMAKE_CURRENT_BINARY_DIR}/"
    COPYONLY)

add_test(NAME test_kernel
    COMMAND ${PYTEST} test_kernel.py)
set_tests_properties(test_kernel
    PROPERTIES
    ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")

# Test_kernel_control tests
# =========================

set(TEST_KERNEL_SPLIT_SOURCES
    xmock_interpreter.cpp
    xmock_interpreter.hpp
    main_control.cpp)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel_control/kernel.json.in"
    "kernels/test_kernel_control/kernel.json"
)

add_executable(test_kernel_control ${TEST_KERNEL_SPLIT_SOURCES})
target_link_libraries(test_kernel_control PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
target_compile_features(test_kernel_control PRIVATE cxx_std_11)

set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel_control.py"
    "${CMAKE_CURRENT_BINARY_DIR}/"
    COPYONLY)

add_test(NAME test_kernel_control
    COMMAND ${PYTEST} test_kernel_control.py)
set_tests_properties(test_kernel_control
    PROPERTIES
    ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")

# Test_kernel_shell tests
# =======================

set(TEST_KERNEL_SPLIT_SOURCES
    xmock_interpreter.cpp
    xmock_interpreter.hpp
    main_shell.cpp)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel_shell/kernel.json.in"
    "kernels/test_kernel_shell/kernel.json"
)

add_executable(test_kernel_shell ${TEST_KERNEL_SPLIT_SOURCES})
target_link_libraries(test_kernel_shell PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
target_compile_features(test_kernel_shell PRIVATE cxx_std_11)

set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

configure_file(
    "${XEUS_ZMQ_TEST_DIR}/test_kernel_shell.py"
    "${CMAKE_CURRENT_BINARY_DIR}/"
    COPYONLY)

add_test(NAME test_kernel_shell
    COMMAND ${PYTEST} test_kernel_shell.py)
set_tests_properties(test_kernel_shell
    PROPERTIES
    ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")

if (UNIX)

    # Test_kernel_ipc
    # ===============

    set(TEST_KERNEL_IPC_SOURCES
        xmock_interpreter.cpp
        xmock_interpreter.hpp
        main_ipc.cpp)

    add_executable(test_kernel_ipc ${TEST_KERNEL_IPC_SOURCES})
    target_link_libraries(test_kernel_ipc PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
    target_compile_features(test_kernel_ipc PRIVATE cxx_std_11)

    # Test_client_ipc
    # ===============

    set(TEST_CLIENT_IPC_SOURCES
        client_ipc.cpp)

    add_executable(test_client_ipc ${TEST_CLIENT_IPC_SOURCES})
    target_link_libraries(test_client_ipc PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
    target_compile_features(test_client_ipc PRIVATE cxx_std_11)

endif (UNIX)

=== debian/changelog ===
xeus-zmq (1.1.1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:57 +1100

xeus-zmq (1.1.1-2build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:17:19 +0000

xeus-zmq (1.1.1-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3, xeus 3.1.3-2
    This should resolve an issue with different versions of the nlohmann::json
    API being exposed in the libxeus API.

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:17:47 +0100

xeus-zmq (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 10:35:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                cppzmq-dev,
-               xeus-dev (>= 3.1.1~),
-               nlohmann-json3-dev,
+               xeus-dev (>= 3.1.3-2~),
+               nlohmann-json3-dev (>= 3.11.3~),
                libssl-dev,
                pkg-config,
                doctest-dev,
@@ -32,9 +33,9 @@
 Architecture: any
 Depends: ${misc:Depends},
          libxeus-zmq2 (= ${binary:Version}),
-         xeus-dev (>= 3.1.1~),
+         xeus-dev (>= 3.1.3-2~),
          cppzmq-dev,
-         nlohmann-json3-dev,
+         nlohmann-json3-dev (>= 3.11.3~),
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)
  xeus enables custom kernel authors to implement Jupyter kernels more

## xeus-zmq 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,6 +55,9 @@
 # Test options
 option(XEUS_ZMQ_BUILD_TESTS "xeus test suite" OFF)
 
+# Option to build without libsodium
+option(XEUS_ZMQ_BUILD_WITHOUT_LIBSODIUM "Build xeus-zmq without libsodium" OFF)
+
 # Static build configuration
 # ==========================
 
@@ -79,21 +82,24 @@
 # Dependencies
 # ============
 
-set(xeus_REQUIRED_VERSION 3.1.1)
-set(nlohmann_json_REQUIRED_VERSION 3.2.0)
+set(xeus_REQUIRED_VERSION 5.0.0)
+set(nlohmann_json_REQUIRED_VERSION 3.11.3)
 set(cppzmq_REQUIRED_VERSION 4.8.1)
 set(zeromq_REQUIRED_VERSION 4.3.2)
 
 if (NOT TARGET xeus AND NOT TARGET xeus-static)
     find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found xeus ${xeus_VERSION}")
 endif ()
 
 if (NOT TARGET nlohmann_json)
     find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found nlohmann_json ${nlohmann_json_VERSION}")
 endif ()
 
 if (NOT TARGET cppzmq AND NOT TARGET cppzmq-static)
     find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found cppzmq ${cppzmq_VERSION}")
 endif ()
 
 if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
@@ -123,53 +129,90 @@
 # ============
 
 set(XEUS_ZMQ_HEADERS
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xauthentication.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xclient_zmq.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xcontrol_default_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xcontrol_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdebugger_base.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_control_main.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xmiddleware.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_shell_main.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq_split.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xshell_default_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xshell_runner.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xthread.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_context.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_serializer.hpp
 )
 
 set(XEUS_ZMQ_SOURCES
-    ${XEUS_ZMQ_SOURCE_DIR}/xauthentication.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xdap_tcp_client.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xdebugger_base.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xmiddleware.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_control_main.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_shell_main.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq_split.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xshell.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xshell.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_context.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_serializer.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_messenger.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xdealer_channel.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xdealer_channel.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xheartbeat_client.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xheartbeat_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xiopub_client.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xiopub_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xauthentication.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xauthentication.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xmiddleware.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xmiddleware_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_context.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_serializer.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_serializer.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_base.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_middleware.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_middleware.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol_default_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xheartbeat.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xheartbeat.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xpublisher.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xpublisher.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_control_main.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_control_main.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_shell_main.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_shell_main.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_default.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_default.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell_default_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xtrivial_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xtrivial_messenger.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xzmq_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xzmq_messenger.cpp
 )
 
 # Targets and link
 # ================
 
+# Binaries that link with xeus-zmq must be able to find and load
+# libzmq. However, since xeus-zmq privately links with libzmq,
+# we need to tell cmake to append to rpath directories containing
+# linked libraries.
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
 include(CheckCXXCompilerFlag)
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
 
-if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE)
+if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE AND NOT XEUS_ZMQ_BUILD_WITHOUT_LIBSODIUM)
 	# Explicitly finds and links with libsodium.a
 	# because it is not exported as a dependency by
 	# the static build of libzmq. Remove this when
@@ -198,10 +241,10 @@
 
     target_link_libraries(
         ${target_name}
-        PUBLIC ${CPPZMQ_TARGET_NAME}
         PUBLIC nlohmann_json::nlohmann_json
-        PUBLIC OpenSSL::Crypto
         PUBLIC ${XEUS_TARGET_NAME}
+        PRIVATE ${CPPZMQ_TARGET_NAME}
+        PRIVATE OpenSSL::Crypto
     )
 
     if (NOT MSVC)
@@ -244,77 +287,3 @@
             SOVERSION ${XEUS_ZMQ_BINARY_CURRENT}
             OUTPUT_NAME "lib${output_name}"
         )
-    endif()
-
-    # Compilation flags
-    # =================
-
-    target_compile_features(${target_name} PRIVATE cxx_std_14)
-
-    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
-        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
-        CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-
-        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
-
-        message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
-    endif()
-
-    if (${linkage_upper} STREQUAL "STATIC")
-        target_compile_definitions(${target_name} PUBLIC XEUS_ZMQ_STATIC_LIB)
-    endif ()
-
-    if (MSVC)
-        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
-        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
-        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
-    elseif (APPLE)
-        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
-    else ()
-        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
-    endif ()
-
-    if (XEUS_ZMQ_STATIC_DEPENDENCIES)
-        if (CMAKE_DL_LIBS)
-            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS})
-        endif ()
-        if (UNIX AND NOT APPLE)
-            target_link_libraries(${target_name} PRIVATE util rt)
-        endif ()
-    endif ()
-endmacro()
-
-set(xeus_zmq_targets "")
-
-if (XEUS_ZMQ_BUILD_SHARED_LIBS)
-    xeus_zmq_create_target(xeus-zmq SHARED xeus-zmq)
-    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
-        # Do not reexport OpenSSL symbols from xeus, for libraries
-        #   Prevents conflicts with other versions of OpenSSL
-        #   loaded in the same process namespace, which can cause
-        #   crashes if the versions are not compatible.
-        set_target_properties(xeus-zmq PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
-    endif()
-    list(APPEND xeus_zmq_targets xeus-zmq)
-endif ()
-
-if (XEUS_ZMQ_BUILD_STATIC_LIBS)
-    # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq-static)
-    else ()
-        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq)
-    endif ()
-
-    list(APPEND xeus_zmq_targets xeus-zmq-static)
-endif ()
-
-# Tests
-# =====
-
-# We need to control from outside whether we enable testing or not. We cannot
-# rely on BUILD_TESTING since it doe snot exist until CTest is included.
-
-include(CTest)
-

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -88,7 +88,7 @@
 
 add_executable(test_kernel ${TEST_KERNEL_SOURCES})
 target_link_libraries(test_kernel PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
-target_compile_features(test_kernel PRIVATE cxx_std_11)
+target_compile_features(test_kernel PRIVATE cxx_std_17)
 
 set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)
 
@@ -118,7 +118,7 @@
 
 add_executable(test_kernel_control ${TEST_KERNEL_SPLIT_SOURCES})
 target_link_libraries(test_kernel_control PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
-target_compile_features(test_kernel_control PRIVATE cxx_std_11)
+target_compile_features(test_kernel_control PRIVATE cxx_std_17)
 
 set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)
 
@@ -148,7 +148,7 @@
 
 add_executable(test_kernel_shell ${TEST_KERNEL_SPLIT_SOURCES})
 target_link_libraries(test_kernel_shell PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
-target_compile_features(test_kernel_shell PRIVATE cxx_std_11)
+target_compile_features(test_kernel_shell PRIVATE cxx_std_17)
 
 set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)
 
@@ -175,16 +175,18 @@
 
     add_executable(test_kernel_ipc ${TEST_KERNEL_IPC_SOURCES})
     target_link_libraries(test_kernel_ipc PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
-    target_compile_features(test_kernel_ipc PRIVATE cxx_std_11)
+    target_compile_features(test_kernel_ipc PRIVATE cxx_std_17)
 
     # Test_client_ipc
     # ===============
 
     set(TEST_CLIENT_IPC_SOURCES
+        xipc_client.cpp
+        xipc_client.hpp
         client_ipc.cpp)
 
     add_executable(test_client_ipc ${TEST_CLIENT_IPC_SOURCES})
     target_link_libraries(test_client_ipc PRIVATE ${xeus-zmq_TARGET} Threads::Threads)
-    target_compile_features(test_client_ipc PRIVATE cxx_std_11)
+    target_compile_features(test_client_ipc PRIVATE cxx_std_17)
 
 endif (UNIX)

=== debian/changelog ===
xeus-zmq (3.1.0-0.3) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * Upload to unstable.
  * debian/control:
    - xeus-zmq-dev: Depends on xeus-dev (>= 5.0.0), cppzmq-dev (>= 4.8.1)

 -- Bill Allombert <ballombe@debian.org>  Sat, 28 Dec 2024 11:11:46 +0100

xeus-zmq (3.1.0-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * debian/control:
    - Build-Depends on xeus-dev (>= 5.0.0), cppzmq-dev (>= 4.8.1)

 -- Bill Allombert <ballombe@debian.org>  Mon, 28 Oct 2024 19:18:18 +0100

xeus-zmq (3.1.0-0.1) experimental; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release
    - New soname: libxeus-zmq2 -> libxeus-zmq6
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config.
    - New library name: libxeus-zmq2 -> libxeus-zmq6
  * debian/libxeus-zmq2.install: rename to debian/libxeus-zmq6.install

 -- Bill Allombert <ballombe@debian.org>  Sat, 19 Oct 2024 13:24:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               cppzmq-dev,
-               xeus-dev (>= 3.1.3-2~),
+               cppzmq-dev (>= 4.8.1),
+               xeus-dev (>= 5.0.0),
                nlohmann-json3-dev (>= 3.11.3~),
                libssl-dev,
-               pkg-config,
+               pkgconf,
                doctest-dev,
 Standards-Version: 4.6.2
 Section: libs
@@ -18,7 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus-zmq2
+Package: libxeus-zmq6
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: ZeroMQ middleware for xeus (library)
@@ -32,9 +31,9 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus-zmq2 (= ${binary:Version}),
-         xeus-dev (>= 3.1.3-2~),
-         cppzmq-dev,
+         libxeus-zmq6 (= ${binary:Version}),
+         xeus-dev (>= 5.0.0),
+         cppzmq-dev (>= 4.8.1),
          nlohmann-json3-dev (>= 3.11.3~),
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)

## xeus-zmq 3.1.1

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # Unit tests
 # ==========
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.8)
 
 if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     project(xeus-zmq-test)

=== debian/changelog ===
xeus-zmq (3.1.1-0.1) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release.
  * debian/watch: add missing 'debian uupdate'
  * debian/control:
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev
   - xeus-zmq-dev: 
     + Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev

 -- Bill Allombert <ballombe@debian.org>  Fri, 31 Oct 2025 11:55:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                cmake,
                cppzmq-dev (>= 4.8.1),
                xeus-dev (>= 5.0.0),
-               nlohmann-json3-dev (>= 3.11.3~),
+               nlohmann-json3.12-dev,
                libssl-dev,
                pkgconf,
                doctest-dev,
@@ -34,7 +34,7 @@
          libxeus-zmq6 (= ${binary:Version}),
          xeus-dev (>= 5.0.0),
          cppzmq-dev (>= 4.8.1),
-         nlohmann-json3-dev (>= 3.11.3~),
+         nlohmann-json3.12-dev,
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)
  xeus enables custom kernel authors to implement Jupyter kernels more

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-zmq/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@

## xeus-zmq 3.1.2

=== debian/changelog ===
xeus-zmq (3.1.2-1) unstable; urgency=medium

  * New upstream release.
  * New maintainer.
  * debian/control:
    - Update Standards-Version to 4.7.3
    - libxeus-zmq6: mark Multi-Arch: same
    - Remove Vcs-Git, Vcs-Browser.
  * debian/watch: add missing 'debian uupdate'

 -- Bill Allombert <ballombe@debian.org>  Wed, 25 Feb 2026 21:12:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Gordon Ball <gordon@chronitis.net>
+Maintainer: Bill Allombert <ballombe@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                cppzmq-dev (>= 4.8.1),
@@ -10,16 +9,15 @@
                libssl-dev,
                pkgconf,
                doctest-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/jupyter-xeus/xeus-zmq
-Vcs-Git: https://salsa.debian.org/science-team/xeus-zmq.git
-Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
 Package: libxeus-zmq6
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
 Description: ZeroMQ middleware for xeus (library)
  xeus-zmq provides the ZMQ transport for the Jupyter kernel protocol. This
  was formerly part of libxeus but was split into a separate library for

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-zmq/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
